                                          <%-- Displays Where class loaded from --%>
<%@ page import="java.io.*,java.net.*,java.security.*,javax.jcr.*,javax.servlet.jsp.JspWriter" %>
<%!

   public void displayClasses (String p_itemList, JspWriter out) throws IOException
   {
    if (p_itemList != null)
    {
      String[] items = p_itemList.split("\\s");
      for (int i = 0; i < items.length; i++)
      {
        if (items[i].length() != 0)
        {
           try {
            Class cls = Class.forName(items[i]);
            ProtectionDomain pDomain = cls.getProtectionDomain();
            CodeSource cSource = pDomain.getCodeSource();
            URL loc = cSource.getLocation();
            if (loc.toString().length() > 0) {
             displayClass(items[i], loc, out);       
            }
           } 
           catch (Exception e) {
            System.out.println("Exception e " + e);
           }
           finally
           {
              }
        }
      }
    }
   }

   public void displayClass (String p_indent, URL p_node, JspWriter out) throws IOException
   {
      out.println("--------------------------------------------------------------------------------------------------------------------------");
      out.println(p_indent + ".class loaded from following location:");
      out.println("<B>" + p_node + "</B>");      
      out.println("--------------------------------------------------------------------------------------------------------------------------");
      out.println("");      
   }
%>
<h3>Display Class Location</h3>
<form>
NOTE:  This is a debug jsp that will allow you to search a running jvm to identify where classes are being loaded from.	It is not supported by IBM.
Enter the fully qualified class name to find. e.g. com.ibm.commerce.security.Protectable<br>
<textarea name="classNames" cols="120" rows="10"><% if(request.getParameter("classNames") != null){%><%=request.getParameter("classNames")%><%}%></textarea><br>
<br>
<br><input type="submit" value="Display Class Location">
</form>
<%
   String classNames = request.getParameter("classNames");
   String searchType = request.getParameter("searchType");
   if (classNames != null && !"".equals(classNames.trim()))
   {
%>
<pre>
<%
      displayClasses(classNames, out);
%>
</pre>
<% } %>


